Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR6.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR6.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/IHR/IHR6.cs	(revision 16171)
@@ -21,4 +21,5 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -31,15 +32,11 @@
   public class IHR6 : IHR {
     protected override IEnumerable<double[]> GetOptimalParetoFront(int objectives) {
-      List<double[]> res = new List<double[]>();
-      for (int i = 0; i <= 500; i++) {
-        RealVector r = new RealVector(objectives);
+      var res = new List<double[]>();
+      for (var i = 0; i <= 500; i++) {
+        var r = new RealVector(objectives);
         r[0] = 1 / 500.0 * i;
         res.Add(this.Evaluate(r, objectives));
       }
       return res;
-    }
-
-    protected override double GetBestKnownHypervolume(int objectives) {
-      return Hypervolume.Calculate(GetOptimalParetoFront(objectives), GetReferencePoint(objectives), GetMaximization(objectives));
     }
 
@@ -65,6 +62,6 @@
 
     protected override double G(RealVector y) {
-      double sum = 0.0;
-      for (int i = 1; i < y.Length; i++) {
+      var sum = 0.0;
+      for (var i = 1; i < y.Length; i++) {
         sum += HG(y[i]);
       }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/CIGTAB.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/CIGTAB.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/CIGTAB.cs	(revision 16171)
@@ -21,7 +21,9 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -43,7 +45,7 @@
 
     protected override IEnumerable<double[]> GetOptimalParetoFront(int objecitves) {
-      List<double[]> res = new List<double[]>();
-      for (int i = 0; i <= 500; i++) {
-        RealVector r = new RealVector(2);
+      var res = new List<double[]>();
+      for (var i = 0; i <= 500; i++) {
+        var r = new RealVector(2);
         r[0] = 2 / 500.0 * i;
         r[1] = 2 / 500.0 * i;
@@ -54,5 +56,5 @@
 
     protected override double GetBestKnownHypervolume(int objectives) {
-      return Hypervolume.Calculate(GetOptimalParetoFront(objectives), GetReferencePoint(objectives), GetMaximization(objectives));
+      return HypervolumeCalculator.CalculateHypervolume(GetOptimalParetoFront(objectives).ToArray(), GetReferencePoint(objectives), GetMaximization(objectives));
     }
 
@@ -68,8 +70,8 @@
     public override double[] Evaluate(RealVector r, int objectives) {
       if (objectives != 2) throw new ArgumentException("The CIGTAB problem must always have 2 objectives");
-      double x = r[0];
+      var x = r[0];
       double a = 1000;
-      double sum = x * x;
-      for (int i = 1; i < r.Length - 1; i++) {
+      var sum = x * x;
+      for (var i = 1; i < r.Length - 1; i++) {
         sum += a * r[i] * r[i];
       }
@@ -77,9 +79,9 @@
 
       //objective1
-      double f0 = 1 / (a * a * r.Length) * sum;
+      var f0 = 1 / (a * a * r.Length) * sum;
 
       x = x - 2;
       sum = x * x;
-      for (int i = 1; i < r.Length - 1; i++) {
+      for (var i = 1; i < r.Length - 1; i++) {
         sum += a * (r[i] - 2) * (r[i] - 2);
       }
@@ -87,5 +89,5 @@
       sum += a * a * (r[r.Length - 1] - 2) * (r[r.Length - 1] - 2);
       //objective0
-      double f1 = 1 / (a * a * r.Length) * sum;
+      var f1 = 1 / (a * a * r.Length) * sum;
 
       return new double[] { f0, f1 };
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/ELLI1.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/ELLI1.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/ELLI1.cs	(revision 16171)
@@ -21,7 +21,9 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -43,7 +45,7 @@
 
     protected override IEnumerable<double[]> GetOptimalParetoFront(int objecitves) {
-      List<double[]> res = new List<double[]>();
-      for (int i = 0; i <= 500; i++) {
-        RealVector r = new RealVector(2);
+      var res = new List<double[]>();
+      for (var i = 0; i <= 500; i++) {
+        var r = new RealVector(2);
         r[0] = 2 / 500.0 * i;
         r[1] = 2 / 500.0 * i;
@@ -54,5 +56,5 @@
 
     protected override double GetBestKnownHypervolume(int objectives) {
-      return Hypervolume.Calculate(GetOptimalParetoFront(objectives), GetReferencePoint(objectives), GetMaximization(objectives));
+      return HypervolumeCalculator.CalculateHypervolume(GetOptimalParetoFront(objectives).ToArray(), GetReferencePoint(objectives), GetMaximization(objectives));
     }
 
@@ -69,18 +71,18 @@
       if (objectives != 2) throw new ArgumentException("The ELLI problem must always have 2 objectives");
       double a = 1000;
-      double sum = 0.0;
-      for (int i = 0; i < r.Length; i++) {
+      var sum = 0.0;
+      for (var i = 0; i < r.Length; i++) {
         sum += Math.Pow(a, 2 * i / (r.Length - 1)) * r[i] * r[i];
       }
 
       //objective1
-      double f0 = 1 / (a * a * r.Length) * sum;
+      var f0 = 1 / (a * a * r.Length) * sum;
 
       sum = 0.0;
-      for (int i = 0; i < r.Length; i++) {
+      for (var i = 0; i < r.Length; i++) {
         sum += Math.Pow(a, 2 * i / (r.Length - 1)) * (r[i] - 2) * (r[i] - 2);
       }
       //objective0
-      double f1 = 1 / (a * a * r.Length) * sum;
+      var f1 = 1 / (a * a * r.Length) * sum;
 
       return new double[] { f0, f1 };
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/Fonseca.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/Fonseca.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/Fonseca.cs	(revision 16171)
@@ -22,7 +22,9 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -44,5 +46,5 @@
 
     protected override double GetBestKnownHypervolume(int objectives) {
-      return Hypervolume.Calculate(GetOptimalParetoFront(objectives), GetReferencePoint(objectives), GetMaximization(objectives));
+      return HypervolumeCalculator.CalculateHypervolume(GetOptimalParetoFront(objectives).ToArray(), GetReferencePoint(objectives), GetMaximization(objectives));
     }
 
@@ -65,6 +67,6 @@
 
       //objective1
-      for (int i = 0; i < r.Length; i++) {
-        double d = r[i] - aux;
+      for (var i = 0; i < r.Length; i++) {
+        var d = r[i] - aux;
         f0 += d * d;
       }
@@ -72,7 +74,7 @@
 
       //objective2
-      double f1 = 0.0;
-      for (int i = 0; i < r.Length; i++) {
-        double d = r[i] + aux;
+      var f1 = 0.0;
+      for (var i = 0; i < r.Length; i++) {
+        var d = r[i] + aux;
         f1 += d * d;
       }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/Kursawe.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/Kursawe.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/Kursawe.cs	(revision 16171)
@@ -21,7 +21,9 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -43,5 +45,5 @@
 
     protected override double GetBestKnownHypervolume(int objectives) {
-      return Hypervolume.Calculate(GetOptimalParetoFront(objectives), GetReferencePoint(objectives), GetMaximization(objectives));
+      return HypervolumeCalculator.CalculateHypervolume(GetOptimalParetoFront(objectives).ToArray(), GetReferencePoint(objectives), GetMaximization(objectives));
     }
 
@@ -65,11 +67,11 @@
       if (objectives != 2) throw new ArgumentException("The Kursawe problem must always have 2 objectives");
       //objective 1
-      double f0 = 0.0;
-      for (int i = 0; i < r.Length - 1; i++) {
+      var f0 = 0.0;
+      for (var i = 0; i < r.Length - 1; i++) {
         f0 += -10 * Math.Exp(-0.2 * Math.Sqrt(r[i] * r[i] + r[i + 1] * r[i + 1]));
       }
       //objective2
-      double f1 = 0.0;
-      for (int i = 0; i < r.Length; i++) {
+      var f1 = 0.0;
+      for (var i = 0; i < r.Length; i++) {
         f1 += Math.Pow(Math.Abs(r[i]), 0.8) + 5 * Math.Sin(Math.Pow(r[i], 3));
       }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/SchafferN1.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/SchafferN1.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/SchafferN1.cs	(revision 16171)
@@ -21,7 +21,9 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -48,5 +50,5 @@
 
     protected override double GetBestKnownHypervolume(int objectives) {
-      return Hypervolume.Calculate(GetOptimalParetoFront(objectives), GetReferencePoint(objectives), GetMaximization(objectives));
+      return HypervolumeCalculator.CalculateHypervolume(GetOptimalParetoFront(objectives).ToArray(), GetReferencePoint(objectives), GetMaximization(objectives));
     }
 
@@ -63,11 +65,11 @@
       if (objectives != 2) throw new ArgumentException("The Schaffer N1 problem must always have 2 objectives");
       if (r.Length != 1) return null;
-      double x = r[0];
+      var x = r[0];
 
       //objective1
-      double f0 = x * x;
+      var f0 = x * x;
 
       //objective0
-      double f1 = x - 2;
+      var f1 = x - 2;
       f1 *= f1;
 
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/SchafferN2.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/SchafferN2.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/Misc/SchafferN2.cs	(revision 16171)
@@ -59,5 +59,5 @@
     public override double[] Evaluate(RealVector r, int objectives) {
       if (objectives != 2) throw new ArgumentException("The Schaffer N1 problem must always have 2 objectives");
-      double x = r[0];
+      var x = r[0];
 
       //objective1
@@ -69,5 +69,5 @@
 
       //objective0
-      double f1 = x - 5;
+      var f1 = x - 5;
       f1 *= f1;
 
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ParetoFrontStore.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ParetoFrontStore.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ParetoFrontStore.cs	(revision 16171)
@@ -29,7 +29,7 @@
   internal class ParetoFrontStore {
     internal static IEnumerable<double[]> GetParetoFront(String filename) {
-      List<double[]> data = new List<double[]>();
+      var data = new List<double[]>();
       var assembly = Assembly.GetExecutingAssembly();
-      String ressourcename = typeof(ParetoFrontStore).Namespace + ".TestFunctions." + filename + ".pf";
+      var ressourcename = typeof(ParetoFrontStore).Namespace + ".TestFunctions." + filename + ".pf";
 
       //check if file is listed
@@ -42,6 +42,6 @@
       while ((s = ressourceReader.ReadLine()) != null) {
         var tokens = s.Split(new char[0], StringSplitOptions.RemoveEmptyEntries);
-        double[] point = new double[tokens.Length];
-        for (int i = 0; i < point.Length; i++) {
+        var point = new double[tokens.Length];
+        for (var i = 0; i < point.Length; i++) {
           point[i] = Double.Parse(tokens[i], CultureInfo.InvariantCulture);
         }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT1.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT1.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT1.cs	(revision 16171)
@@ -44,8 +44,8 @@
     public override double[] Evaluate(RealVector r) {
       double g = 0;
-      for (int i = 1; i < r.Length; i++) g += r[i];
+      for (var i = 1; i < r.Length; i++) g += r[i];
       g = 1.0 + 9.0 * g / (r.Length - 1);
-      double f0 = r[0];
-      double f1 = g * (1.0 - Math.Sqrt(r[0] / g));
+      var f0 = r[0];
+      var f1 = g * (1.0 - Math.Sqrt(r[0] / g));
       return new double[] { f0, f1 };
     }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT2.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT2.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT2.cs	(revision 16171)
@@ -42,9 +42,9 @@
     public override double[] Evaluate(RealVector r) {
       double g = 0;
-      for (int i = 1; i < r.Length; i++) g += r[i];
+      for (var i = 1; i < r.Length; i++) g += r[i];
       g = 1.0 + 9.0 * g / (r.Length - 1);
-      double d = r[0] / g;
-      double f0 = r[0];
-      double f1 = g * (1.0 - d * d);
+      var d = r[0] / g;
+      var f0 = r[0];
+      var f1 = g * (1.0 - d * d);
       return new double[] { f0, f1 };
     }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT3.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT3.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT3.cs	(revision 16171)
@@ -44,9 +44,9 @@
     public override double[] Evaluate(RealVector r) {
       double g = 0;
-      for (int i = 1; i < r.Length; i++) g += r[i];
+      for (var i = 1; i < r.Length; i++) g += r[i];
       g = 1.0 + 9.0 * g / (r.Length - 1);
-      double d = r[0] / g;
-      double f0 = r[0];
-      double f1 = g * (1.0 - Math.Sqrt(d) - d * Math.Sin(10 * Math.PI * r[0]));
+      var d = r[0] / g;
+      var f0 = r[0];
+      var f1 = g * (1.0 - Math.Sqrt(d) - d * Math.Sin(10 * Math.PI * r[0]));
       return new double[] { f0, f1 };
     }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT4.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT4.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT4.cs	(revision 16171)
@@ -30,7 +30,7 @@
   public class ZDT4 : ZDT {
     protected override double[,] GetBounds(int objectives) {
-      double[,] bounds = new double[objectives, 2];
+      var bounds = new double[objectives, 2];
       bounds[0, 0] = 0; bounds[0, 1] = 1;
-      for (int i = 1; i < objectives; i++) {
+      for (var i = 1; i < objectives; i++) {
         bounds[i, 0] = -5;
         bounds[i, 1] = 5;
@@ -53,12 +53,12 @@
     public override double[] Evaluate(RealVector r) {
       double g = 0;
-      for (int i = 1; i < r.Length; i++) {
-        double v = r[i];
+      for (var i = 1; i < r.Length; i++) {
+        var v = r[i];
         g += v * v - 10 * Math.Cos(4 * Math.PI * v);
       }
       g = 1.0 + 10.0 * (r.Length - 1) + g;
-      double d = r[0] / g;
-      double f0 = r[0];
-      double f1 = 1 - Math.Sqrt(d);
+      var d = r[0] / g;
+      var f0 = r[0];
+      var f1 = 1 - Math.Sqrt(d);
       return new double[] { f0, f1 };
     }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT6.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT6.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/TestFunctions/ZDT/ZDT6.cs	(revision 16171)
@@ -43,9 +43,9 @@
     public override double[] Evaluate(RealVector r) {
       double g = 0;
-      for (int i = 1; i < r.Length; i++) g += r[i];
+      for (var i = 1; i < r.Length; i++) g += r[i];
       g = 1.0 + 9.0 * Math.Pow(g / (r.Length - 1), 0.25);
-      double f1 = 1 - Math.Exp(-4 * r[0]) * Math.Pow(Math.Sin(6 * Math.PI * r[0]), 6);
-      double d = f1 / g;
-      double f2 = g * (1.0 - d * d);
+      var f1 = 1 - Math.Exp(-4 * r[0]) * Math.Pow(Math.Sin(6 * Math.PI * r[0]), 6);
+      var d = f1 / g;
+      var f2 = g * (1.0 - d * d);
       return new double[] { f1, f2 };
     }
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Utilities.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Utilities.cs	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Problems.TestFunctions.MultiObjective/3.3/Utilities.cs	(revision 16171)
@@ -26,32 +26,13 @@
 namespace HeuristicLab.Problems.TestFunctions.MultiObjective {
   internal static class Utilities {
-    internal static double MinimumDistance(double[] point, IEnumerable<double[]> points) {
-      if (point == null) throw new ArgumentNullException("Point must not be null.");
-      if (points == null) throw new ArgumentNullException("Points must not be null.");
-      if (!points.Any()) throw new ArgumentException("Points must not be empty.");
-
-      double minDistance = double.MaxValue;
-      foreach (double[] r in points) {
-        if (r.Length != point.Length) throw new ArgumentException("Dimensions of Points and Point do not match.");
-
-        double squaredDistance = 0;
-        for (int i = 0; i < r.Length; i++) {
-          squaredDistance += (point[i] - r[i]) * (point[i] - r[i]);
-        }
-        minDistance = Math.Min(squaredDistance, minDistance);
-      }
-
-      return Math.Sqrt(minDistance);
-    }
-
     internal static DoubleMatrix ToMatrix(IEnumerable<double[]> source) {
       try {
-        int firstDimension = source.Count();
-        int secondDimension = source.GroupBy(row => row.Length).Single().Key; // throws InvalidOperationException if source is not rectangular
+        var firstDimension = source.Count();
+        var secondDimension = source.GroupBy(row => row.Length).Single().Key; // throws InvalidOperationException if source is not rectangular
 
         var result = new DoubleMatrix(firstDimension, secondDimension);
         var enumarator = source.GetEnumerator();
-        for (int i = 0; i < firstDimension && enumarator.MoveNext(); ++i)
-          for (int j = 0; j < secondDimension; ++j)
+        for (var i = 0; i < firstDimension && enumarator.MoveNext(); ++i)
+          for (var j = 0; j < secondDimension; ++j)
             result[i, j] = enumarator.Current[j];
         return result;
@@ -62,19 +43,5 @@
     }
 
-    internal class DimensionComparer : IComparer<double[]> {
-      private readonly int dim;
-      private readonly int descending;
-
-      public DimensionComparer(int dimension, bool descending) {
-        this.dim = dimension;
-        this.descending = descending ? -1 : 1;
-      }
-
-      public int Compare(double[] x, double[] y) {
-        if (x[dim] < y[dim]) return -descending;
-        else if (x[dim] > y[dim]) return descending;
-        else return 0;
-      }
-    }
+    
   }
 }
Index: branches/2943_MOBasicProblem_MOCMAES/MOCMAES-TestProblem-Rework.sln
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/MOCMAES-TestProblem-Rework.sln	(revision 16159)
+++ branches/2943_MOBasicProblem_MOCMAES/MOCMAES-TestProblem-Rework.sln	(revision 16171)
@@ -11,4 +11,8 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.TestFunctions.MultiObjective-3.3", "HeuristicLab.Problems.TestFunctions.MultiObjective\3.3\HeuristicLab.Problems.TestFunctions.MultiObjective-3.3.csproj", "{D53E8E48-CFAA-4F57-AC35-63BEF4476159}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Optimization.Operators-3.3", "HeuristicLab.Optimization.Operators\3.3\HeuristicLab.Optimization.Operators-3.3.csproj", "{25087811-F74C-4128-BC86-8324271DA13E}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Data-3.3", "HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj", "{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}"
 EndProject
 Global
@@ -70,4 +74,28 @@
 		{D53E8E48-CFAA-4F57-AC35-63BEF4476159}.Release|x86.ActiveCfg = Release|x86
 		{D53E8E48-CFAA-4F57-AC35-63BEF4476159}.Release|x86.Build.0 = Release|x86
+		{25087811-F74C-4128-BC86-8324271DA13E}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{25087811-F74C-4128-BC86-8324271DA13E}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{25087811-F74C-4128-BC86-8324271DA13E}.Debug|x64.ActiveCfg = Debug|x64
+		{25087811-F74C-4128-BC86-8324271DA13E}.Debug|x64.Build.0 = Debug|x64
+		{25087811-F74C-4128-BC86-8324271DA13E}.Debug|x86.ActiveCfg = Debug|x86
+		{25087811-F74C-4128-BC86-8324271DA13E}.Debug|x86.Build.0 = Debug|x86
+		{25087811-F74C-4128-BC86-8324271DA13E}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{25087811-F74C-4128-BC86-8324271DA13E}.Release|Any CPU.Build.0 = Release|Any CPU
+		{25087811-F74C-4128-BC86-8324271DA13E}.Release|x64.ActiveCfg = Release|x64
+		{25087811-F74C-4128-BC86-8324271DA13E}.Release|x64.Build.0 = Release|x64
+		{25087811-F74C-4128-BC86-8324271DA13E}.Release|x86.ActiveCfg = Release|x86
+		{25087811-F74C-4128-BC86-8324271DA13E}.Release|x86.Build.0 = Release|x86
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Debug|x64.ActiveCfg = Debug|x64
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Debug|x64.Build.0 = Debug|x64
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Debug|x86.ActiveCfg = Debug|x86
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Debug|x86.Build.0 = Debug|x86
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Release|Any CPU.Build.0 = Release|Any CPU
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Release|x64.ActiveCfg = Release|x64
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Release|x64.Build.0 = Release|x64
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Release|x86.ActiveCfg = Release|x86
+		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
